(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/router'), require('@angular/common'), require('@angular/core')) :
    typeof define === 'function' && define.amd ? define('ngx-tag-commander', ['exports', '@angular/router', '@angular/common', '@angular/core'], factory) :
    (factory((global['ngx-tag-commander'] = {}),global.ng.router,global.ng.common,global.ng.core));
}(this, (function (exports,i2,i3,i0) { 'use strict';

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @return {?}
     */
    function _window() {
        return window;
    }
    var WindowRef = /** @class */ (function () {
        function WindowRef() {
        }
        Object.defineProperty(WindowRef.prototype, "nativeWindow", {
            get: /**
             * @return {?}
             */ function () {
                return _window();
            },
            enumerable: true,
            configurable: true
        });
        WindowRef.decorators = [
            { type: i0.Injectable }
        ];
        return WindowRef;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * \@dynamic
     */
    var TagCommanderService = /** @class */ (function () {
        function TagCommanderService(winRef, router, _doc, platformId) {
            var _this = this;
            this.winRef = winRef;
            this.router = router;
            this._doc = _doc;
            this.platformId = platformId;
            this._tcContainers = [];
            this._trackRoutes = false;
            this.debug_logger = ( /**
             * @param {...?} args
             * @return {?}
             */function () {
                var args = [];
                for (var _i = 0; _i < arguments.length; _i++) {
                    args[_i] = arguments[_i];
                }
                if (this.debug) {
                    console.log.apply(console, args);
                }
            });
            this.router.events.subscribe(( /**
             * @param {?} _data
             * @return {?}
             */function (_data) {
                if (_data instanceof i2.ActivationEnd && _this._trackRoutes) {
                    if (_data.snapshot.data.tcInclude !== undefined) {
                        /** @type {?} */
                        var data = _data.snapshot.data.tcInclude;
                        data.forEach(( /**
                         * @param {?} container
                         * @return {?}
                         */function (container) {
                            _this.reloadContainer(container["ids"], container["idc"], container["options"]);
                        }));
                    }
                }
            }));
        }
        // /**
        //  * the script URI correspond to the tag-commander script URL, it can either be a CDN URL or the path of your script
        //  * @param {string} id the id the script node will have
        //  * @param {string} uri the source of the script
        //  * @param {string} node the node on witch the script will be placed, it can either be head or body
        // */
        // /**
        //  * the script URI correspond to the tag-commander script URL, it can either be a CDN URL or the path of your script
        //  * @param {string} id the id the script node will have
        //  * @param {string} uri the source of the script
        //  * @param {string} node the node on witch the script will be placed, it can either be head or body
        // */
        /**
         * @param {?} id
         * @param {?} uri
         * @param {?} node
         * @return {?}
         */
        TagCommanderService.prototype.addContainer =
            // /**
            //  * the script URI correspond to the tag-commander script URL, it can either be a CDN URL or the path of your script
            //  * @param {string} id the id the script node will have
            //  * @param {string} uri the source of the script
            //  * @param {string} node the node on witch the script will be placed, it can either be head or body
            // */
            /**
             * @param {?} id
             * @param {?} uri
             * @param {?} node
             * @return {?}
             */
            function (id, uri, node) {
                var _this = this;
                return new Promise(( /**
                 * @param {?} resolve
                 * @return {?}
                 */function (resolve) {
                    _this._tcContainers.push({ id: id, uri: uri });
                    /** @type {?} */
                    var tagContainer = _this._doc.createElement("script");
                    tagContainer.onload = ( /**
                     * @return {?}
                     */function () { return resolve(); });
                    tagContainer.setAttribute("type", "text/javascript");
                    tagContainer.setAttribute("src", uri);
                    tagContainer.setAttribute("id", id);
                    if (typeof node !== "string") {
                        _this.debug_logger("you didn't specify where you wanted to place the script, it will be placed in the head by default");
                        _this._doc.querySelector("head").appendChild(tagContainer);
                    }
                    else if (node.toLowerCase() === "head" || node.toLowerCase() === "body") {
                        _this._doc.querySelector(node.toLowerCase()).appendChild(tagContainer);
                    }
                    else {
                        _this.debug_logger("you didn't correctily specify where you wanted to place the script, it will be placed in the head by default");
                        _this._doc.querySelector("head").appendChild(tagContainer);
                    }
                }));
            };
        // /**
        //  * The script URI correspond to the tag-commander script URL, it can either be a CDN URL or the path of your script
        //  * @param {string} id
        //  */
        // /**
        //  * The script URI correspond to the tag-commander script URL, it can either be a CDN URL or the path of your script
        //  * @param {string} id
        //  */
        /**
         * @param {?} id
         * @return {?}
         */
        TagCommanderService.prototype.removeContainer =
            // /**
            //  * The script URI correspond to the tag-commander script URL, it can either be a CDN URL or the path of your script
            //  * @param {string} id
            //  */
            /**
             * @param {?} id
             * @return {?}
             */
            function (id) {
                /** @type {?} */
                var container = this._doc.getElementById(id);
                /** @type {?} */
                var containers = this._tcContainers.slice(0);
                this._doc.querySelector("head").removeChild(container);
                for (var i = 0; i < containers.length; i++) {
                    if (containers[i].id === id) {
                        this._tcContainers.splice(i, 1);
                    }
                }
            };
        // /**
        //  * will display the debug messages if true
        //  * @param {boolean} debug if set to true it will activate the debug msg default is false
        //  */
        // /**
        //  * will display the debug messages if true
        //  * @param {boolean} debug if set to true it will activate the debug msg default is false
        //  */
        /**
         * @param {?} debug
         * @return {?}
         */
        TagCommanderService.prototype.setDebug =
            // /**
            //  * will display the debug messages if true
            //  * @param {boolean} debug if set to true it will activate the debug msg default is false
            //  */
            /**
             * @param {?} debug
             * @return {?}
             */
            function (debug) {
                this.debug = debug;
            };
        // /**
        //  * allows the router to be tracked
        //  * @param {boolean} b will read routes if set to true
        //  */
        // /**
        //  * allows the router to be tracked
        //  * @param {boolean} b will read routes if set to true
        //  */
        /**
         * @param {?} b
         * @return {?}
         */
        TagCommanderService.prototype.trackRoutes =
            // /**
            //  * allows the router to be tracked
            //  * @param {boolean} b will read routes if set to true
            //  */
            /**
             * @param {?} b
             * @return {?}
             */
            function (b) {
                this._trackRoutes = !!b;
            };
        // /**
        //  * set or update the value of the var
        //  * @param {string} tcKey
        //  * @param {*} tcVar
        //  */
        // /**
        //  * set or update the value of the var
        //  * @param {string} tcKey
        //  * @param {*} tcVar
        //  */
        /**
         * @param {?} tcKey
         * @param {?} tcVar
         * @return {?}
         */
        TagCommanderService.prototype.setTcVar =
            // /**
            //  * set or update the value of the var
            //  * @param {string} tcKey
            //  * @param {*} tcVar
            //  */
            /**
             * @param {?} tcKey
             * @param {?} tcVar
             * @return {?}
             */
            function (tcKey, tcVar) {
                if (i3.isPlatformBrowser(this.platformId)) {
                    if (!this.winRef.nativeWindow.tc_vars) {
                        throw new Error('[ngx-tag-commander] setTcVar failed because no window.tc_vars was found. Did you initialize it?');
                    }
                    this.winRef.nativeWindow.tc_vars[tcKey] = tcVar;
                }
            };
        // /**
        //  * set your varibles for the different providers, when called the first time it
        //  * instantiate the external variable
        //  * @param {object} vars
        //  */
        // /**
        //  * set your varibles for the different providers, when called the first time it
        //  * instantiate the external variable
        //  * @param {object} vars
        //  */
        /**
         * @param {?} vars
         * @return {?}
         */
        TagCommanderService.prototype.setTcVars =
            // /**
            //  * set your varibles for the different providers, when called the first time it
            //  * instantiate the external variable
            //  * @param {object} vars
            //  */
            /**
             * @param {?} vars
             * @return {?}
             */
            function (vars) {
                if (i3.isPlatformBrowser(this.platformId)) {
                    this.debug_logger("setTcVars", vars);
                    /** @type {?} */
                    var listOfVars = Object.keys(vars);
                    for (var i = 0; i < listOfVars.length; i++) {
                        this.setTcVar(listOfVars[i], vars[listOfVars[i]]);
                    }
                }
            };
        // /**
        //  * get the value of the var
        //  * @param {string} tcKey
        //  */
        // /**
        //  * get the value of the var
        //  * @param {string} tcKey
        //  */
        /**
         * @param {?} tcKey
         * @return {?}
         */
        TagCommanderService.prototype.getTcVar =
            // /**
            //  * get the value of the var
            //  * @param {string} tcKey
            //  */
            /**
             * @param {?} tcKey
             * @return {?}
             */
            function (tcKey) {
                if (i3.isPlatformBrowser(this.platformId)) {
                    this.debug_logger("getTcVars", tcKey);
                    if (this.winRef.nativeWindow.tc_vars[tcKey] === null) {
                        throw new Error('[ngx-tag-commander]tc_var is undefined. Check that it\'s properly initialized');
                    }
                    return this.winRef.nativeWindow.tc_vars[tcKey];
                }
            };
        // /**
        //  * removes the var by specifying the key
        //  * @param {string} varKey
        //  */
        // /**
        //  * removes the var by specifying the key
        //  * @param {string} varKey
        //  */
        /**
         * @param {?} varKey
         * @return {?}
         */
        TagCommanderService.prototype.removeTcVar =
            // /**
            //  * removes the var by specifying the key
            //  * @param {string} varKey
            //  */
            /**
             * @param {?} varKey
             * @return {?}
             */
            function (varKey) {
                if (i3.isPlatformBrowser(this.platformId)) {
                    this.debug_logger("removeTcVars", varKey);
                    delete this.winRef.nativeWindow.tc_vars[varKey];
                }
            };
        // /**
        //  * will reload all the containers
        //  * @param {object} options can contain some options in a form of an object
        //  */
        // /**
        //  * will reload all the containers
        //  * @param {object} options can contain some options in a form of an object
        //  */
        /**
         * @param {?} options
         * @return {?}
         */
        TagCommanderService.prototype.reloadAllContainers =
            // /**
            //  * will reload all the containers
            //  * @param {object} options can contain some options in a form of an object
            //  */
            /**
             * @param {?} options
             * @return {?}
             */
            function (options) {
                var _this = this;
                if (i3.isPlatformBrowser(this.platformId)) {
                    this.debug_logger("reloadAllContainers", options);
                    options = options || {};
                    this.debug_logger("Reload all containers ", typeof options === "object" ? "with options " + options : "");
                    if (!this.winRef.nativeWindow.tC) {
                        return window.setTimeout(( /**
                         * @return {?}
                         */function () {
                            _this.reloadAllContainers(options);
                        }), 1000);
                    }
                    this.winRef.nativeWindow.tC.container.reload(options);
                }
            };
        // /**
        //  * will reload a specifique container
        //  * @param {number} ids
        //  * @param {number} idc
        //  * @param {object} options can contain some options in a form of an object
        //  */
        // /**
        //  * will reload a specifique container
        //  * @param {number} ids
        //  * @param {number} idc
        //  * @param {object} options can contain some options in a form of an object
        //  */
        /**
         * @param {?} ids
         * @param {?} idc
         * @param {?} options
         * @return {?}
         */
        TagCommanderService.prototype.reloadContainer =
            // /**
            //  * will reload a specifique container
            //  * @param {number} ids
            //  * @param {number} idc
            //  * @param {object} options can contain some options in a form of an object
            //  */
            /**
             * @param {?} ids
             * @param {?} idc
             * @param {?} options
             * @return {?}
             */
            function (ids, idc, options) {
                var _this = this;
                if (i3.isPlatformBrowser(this.platformId)) {
                    /** @type {?} */
                    var options = options || {};
                    this.debug_logger("Reload container ids: " + ids + " idc: " + idc, typeof options === "object" ? "with options: " + options : "");
                    if (!this.winRef.nativeWindow.tC) {
                        return window.setTimeout(( /**
                         * @return {?}
                         */function () {
                            _this.reloadContainer(ids, idc, options);
                        }), 1000);
                    }
                    this.winRef.nativeWindow.tC["container_" + ids + "_" + idc].reload(options);
                }
            };
        // /**
        //  * will set an TagCommander event
        //  * @param {string} eventLabel the name of your event
        //  * @param {HTMLElement} element the HTMLelement on witch the event is attached
        //  * @param {object} data the data you want to transmit
        //  */
        // /**
        //  * will set an TagCommander event
        //  * @param {string} eventLabel the name of your event
        //  * @param {HTMLElement} element the HTMLelement on witch the event is attached
        //  * @param {object} data the data you want to transmit
        //  */
        /**
         * @param {?} eventLabel
         * @param {?} element
         * @param {?} data
         * @param {?=} reloadCapture
         * @return {?}
         */
        TagCommanderService.prototype.captureEvent =
            // /**
            //  * will set an TagCommander event
            //  * @param {string} eventLabel the name of your event
            //  * @param {HTMLElement} element the HTMLelement on witch the event is attached
            //  * @param {object} data the data you want to transmit
            //  */
            /**
             * @param {?} eventLabel
             * @param {?} element
             * @param {?} data
             * @param {?=} reloadCapture
             * @return {?}
             */
            function (eventLabel, element, data, reloadCapture) {
                var _this = this;
                if (reloadCapture === void 0) {
                    reloadCapture = false;
                }
                if (i3.isPlatformBrowser(this.platformId)) {
                    if (reloadCapture === true) {
                        clearTimeout(reloadFunction);
                    }
                    else {
                        this.debug_logger("captureEvent", eventLabel, element, data);
                        if (typeof this.winRef.nativeWindow.tC !== "undefined") {
                            if (eventLabel in this.winRef.nativeWindow.tC.event) {
                                this.winRef.nativeWindow.tC.event[eventLabel](element, data);
                            }
                            if (!(eventLabel in this.winRef.nativeWindow.tC.event)) {
                                /** @type {?} */
                                var reloadFunction = setTimeout(( /**
                                 * @return {?}
                                 */function () {
                                    _this.captureEvent(eventLabel, element, data, reloadCapture = true);
                                }), 1000);
                            }
                        }
                    }
                }
            };
        TagCommanderService.decorators = [
            { type: i0.Injectable, args: [{
                        providedIn: "root"
                    },] }
        ];
        /** @nocollapse */
        TagCommanderService.ctorParameters = function () {
            return [
                { type: WindowRef },
                { type: i2.Router },
                { type: Document, decorators: [{ type: i0.Inject, args: [i3.DOCUMENT,] }] },
                { type: Object, decorators: [{ type: i0.Inject, args: [i0.PLATFORM_ID,] }] }
            ];
        };
        /** @nocollapse */ TagCommanderService.ngInjectableDef = i0.defineInjectable({ factory: function TagCommanderService_Factory() { return new TagCommanderService(i0.inject(WindowRef), i0.inject(i2.Router), i0.inject(i3.DOCUMENT), i0.inject(i0.PLATFORM_ID)); }, token: TagCommanderService, providedIn: "root" });
        return TagCommanderService;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TcSetVarsDirective = /** @class */ (function () {
        function TcSetVarsDirective(el, tcService) {
            this.el = el;
            this.tcService = tcService;
        }
        /**
         * @return {?}
         */
        TcSetVarsDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                this.tcService.setTcVars(this.tcSetVars);
            };
        TcSetVarsDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[tcSetVars]'
                    },] }
        ];
        /** @nocollapse */
        TcSetVarsDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: TagCommanderService }
            ];
        };
        TcSetVarsDirective.propDecorators = {
            tcSetVars: [{ type: i0.Input, args: ['tcSetVars',] }]
        };
        return TcSetVarsDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    // usage [tcEvent]
    var TcEventDirective = /** @class */ (function () {
        function TcEventDirective(el, tcService) {
            this.el = el;
            this.tcService = tcService;
        }
        /**
         * @return {?}
         */
        TcEventDirective.prototype.ngAfterViewInit = /**
         * @return {?}
         */
            function () {
                if (typeof this.tcEvent === 'object' && (this.tcEventLabel === undefined || this.tcEventObj === undefined)) {
                    try {
                        this.tcService.captureEvent(this.tcEvent.eventLabel, this.el, this.tcEvent.data);
                    }
                    catch (e) {
                        console.error(e);
                    }
                }
                else {
                    this.tcService.captureEvent(this.tcEventLabel, this.el, this.tcEventObj);
                }
            };
        TcEventDirective.decorators = [
            { type: i0.Directive, args: [{
                        selector: '[tcEvent]'
                    },] }
        ];
        /** @nocollapse */
        TcEventDirective.ctorParameters = function () {
            return [
                { type: i0.ElementRef },
                { type: TagCommanderService }
            ];
        };
        TcEventDirective.propDecorators = {
            tcEvent: [{ type: i0.Input, args: ['tcEvent',] }],
            tcEventLabel: [{ type: i0.Input, args: ['tcEventLabel',] }],
            tcEventObj: [{ type: i0.Input, args: ['tcEventObj',] }]
        };
        return TcEventDirective;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var NgxTagCommanderModule = /** @class */ (function () {
        function NgxTagCommanderModule() {
        }
        NgxTagCommanderModule.decorators = [
            { type: i0.NgModule, args: [{
                        declarations: [TcSetVarsDirective, TcEventDirective],
                        imports: [
                            i3.CommonModule
                        ],
                        exports: [TcSetVarsDirective, TcEventDirective],
                        providers: [TagCommanderService]
                    },] }
        ];
        return NgxTagCommanderModule;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */

    exports.NgxTagCommanderModule = NgxTagCommanderModule;
    exports.TagCommanderService = TagCommanderService;
    exports.TcEventDirective = TcEventDirective;
    exports.TcSetVarsDirective = TcSetVarsDirective;
    exports.WindowRef = WindowRef;

    Object.defineProperty(exports, '__esModule', { value: true });

})));

//# sourceMappingURL=ngx-tag-commander.umd.js.map